ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.35 by root, Sun Jun 3 15:32:51 2007 UTC vs.
Revision 1.110 by root, Mon Feb 7 20:27:11 2011 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009,2010 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@"; 36my $PNGNQ = "@PNGNQ@";
15 37
16use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
17use Coro::Event; 43use Coro::EV;
18use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
19use IO::AIO (); 47use IO::AIO ();
20use File::Temp; 48use Digest::MD5 ();
21use Crossfire; 49
22use Coro; 50use Coro 5.12;
23use Coro::AIO; 51use Coro::AIO;
24use POSIX (); 52use Coro::Util;
25use Digest::MD5; 53use Coro::Channel;
26use Coro::Storable; $Storable::canonical = 1; 54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
27 59
28sub usage { 60sub usage {
29 warn <<EOF; 61 warn <<EOF;
30Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
31 [--install-arch path] 63 [--install-arch path]
42my $VERBOSE = 1; 74my $VERBOSE = 1;
43my $CACHE = 0; 75my $CACHE = 0;
44my $FORCE; 76my $FORCE;
45my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
46my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
47 80
48our %COLOR = ( 81our %COLOR = (
82 # original cf colours
49 black => 0, 83 black => 0,
50 white => 1, 84 white => 1,
51 navy => 2, 85 navy => 2, # "dark blue"
52 red => 3, 86 red => 3,
53 orange => 4, 87 orange => 4,
54 blue => 5, 88 blue => 5, # "light blue"
55 darkorange => 6, 89 darkorange => 6,
56 green => 7, 90 green => 7,
57 lightgreen => 8, 91 lightgreen => 8,
58 grey => 9, 92 grey => 9,
93 brown => 10, # "yellow"
94 gold => 11, # "light yellow"
95 tan => 12, # yellowish gray
96
97 # new for deliantra
59 brown => 10, 98 none => 13,
99
100 # compatibility to existing archetypes
101 lightblue => 5,
60 gold => 11, 102 gray => 9,
103 yellow => 11,
61 tan => 12, 104 khaki => 12,
62); 105);
63 106
64END { system "rm", "-rf", $TMPDIR } 107END { system "rm", "-rf", $TMPDIR }
65 108
66Event->signal (signal => "INT", cb => sub { exit 1 }); 109my $s_INT = EV::signal INT => sub { exit 1 };
67Event->signal (signal => "TERM", cb => sub { exit 1 }); 110my $s_TERM = EV::signal TERM => sub { exit 1 };
111
112our %hash;
113
114# here we could try to avoid collisions and reduce chksum size further
115sub make_hash($\$\$;$) {
116 my ($id, $dataref, $hashref, $clen) = @_;
117
118 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
119
120 if (exists $hash{$hash}) {
121 # hash collision, but some files are simply identical
122 if (${$hash{$hash}[1]} ne $$dataref) {
123 warn "hash collision $hash{$hash}[0] vs. $id\n";
124 exit 1;
125 } else {
126 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
127 }
128 }
129 $hash{$hash} = [$id, $dataref, $hashref];
130
131 $$hashref = $hash;
132}
68 133
69mkdir $TMPDIR, 0700 134mkdir $TMPDIR, 0700
70 or die "$TMPDIR: $!"; 135 or die "$TMPDIR: $!";
71 136
72sub fork_sub(&) { 137sub fork_sub(&) {
92 if (!-f "$path/regions") { 157 if (!-f "$path/regions") {
93 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 158 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
94 exit 1 unless $FORCE; 159 exit 1 unless $FORCE;
95 } 160 }
96 161
97 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 162 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
163 "$path/.", "$DATADIR/maps/.",
164 "--exclude", "CVS", "--exclude", "/world-precomposed",
165 "--delete", "--delete-excluded"
98 and die "map installation failed.\n"; 166 and die "map installation failed.\n";
99 167
100 print "maps installed successfully.\n"; 168 print "maps installed successfully.\n";
101} 169}
102 170
103{ 171{
104 our %ANIMINFO; 172 our %ANIMINFO;
105 our %FACEINFO; 173 our %FACEINFO;
174 our %RESOURCE;
106 our @ARC; 175 our @ARC;
107 our %ARC; 176 our %ARC;
108 our $TRS; 177 our $TRS;
109 our $NFILE; 178 our $NFILE;
179 our $PATH;
110 180
111 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 181 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
112 182
113 our (@png, @trs, @arc); # files we are interested in 183 our $c_arc = new Coro::Channel;
184 our $c_any = new Coro::Channel;
114 185
186 our @c_png;
187
115 sub commit_png($$$) { 188 sub commit_png($$$$) {
116 my ($name, $data, $T) = @_; 189 my ($stem, $name, $data, $T) = @_;
117 190
191 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
118 $FACEINFO{$name}{"data$T"} = $data; 192 $FACEINFO{$name}{"data$T"} = $data;
119 } 193 }
120 194
121 sub process_png { 195 sub process_png {
122 while (@png) { 196 while (@c_png) {
123 my ($path, $delete) = @{pop @png}; 197 my ($path, $delete) = @{pop @c_png};
124 198
125 my $png; 199 my $png;
126 aio_lstat $path; 200 aio_lstat $path;
127 my ($size, $mtime) = (stat _)[7,9]; 201 my ($size, $mtime) = (stat _)[7,9];
128 202
159 if ($w % $T || $h % $T) { 233 if ($w % $T || $h % $T) {
160 warn "$path: weird png size ($w $h), skipping.\n"; 234 warn "$path: weird png size ($w $h), skipping.\n";
161 next; 235 next;
162 } 236 }
163 237
238 (my $base = $stem) =~ s/^.*\///;
239
240 my $fi = $FACEINFO{$base};
241 unless ($fi) {
242 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
243 #next;
244 }
245
246 my $arc = $fi->{arc} || { };
247
164 unless ($path =~ /~$/) { 248 unless ($path =~ /~$/) {
165 # possibly enlarge 249 # possibly enlarge
166 if (0 > aio_stat "$stem.64x64.png") { 250 if (0 > aio_stat "$stem.64x64.png") {
167 my $other = "$stem.64x64.png~"; 251 my $other = "$stem.64x64.png~";
168 252
169 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 253 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
170 my $wrap = 0; # for the time being
171 fork_sub { 254 fork_sub {
255 my $CROP;
256 my $SRC = "png:\Q$path\E";
257
258 my $is_floor = $arc->{is_floor};
259 my $is_wall = 0;
260
261 my ($wall_pfx, $wall_dir, $wall_sfx);
262
263 if (
264 !$is_floor
265 && !$arc->{alive}
266 && $arc->{move_block} eq "all"
267 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
268 ) {
269 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
270
271 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
272 $is_wall = 1;
273 }
274 }
275
276 if ($is_wall || $is_floor) {
277 # add a 4px border and add other images around it
278 $CROP = "-shave 8x8 +repage";
279
280 $w += 8;
281 $h += 8;
282
283 $SRC = "-size ${w}x${h} xc:transparent";
284 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
285
286 # 8 surrounding images
287 for (
288 # x y b r0 r1
289 [-1, -1, 0, 6],
290 [ 0, -1, 1, 10, 14],
291 [+1, -1, 0, 12],
292
293 [-1, 0, 8, 5, 7],
294 #
295 [+1, 0, 2, 5, 13],
296
297 [-1, +1, 0, 3],
298 [ 0, +1, 4, 10, 11],
299 [+1, +1, 0, 9],
300 ) {
301 my ($x, $y, $d, $r0, $r1) = @$_;
302
303 my $tile = $is_floor ? $path
304 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
305 : die;
306
307 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
308 "\Q$tile",
309 $x * ($w - 8) + 4,
310 $y * ($h - 8) + 4;
311 }
312 }
313
172 system "convert png:\Q$path\E -depth 8 rgba:-" 314 system "convert -depth 8 $SRC rgba:-"
173 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 315 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
174 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 316 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
175 and die "convert/hq2xa pipeline error: status $? ($!)"; 317 and die "convert/cfhq2xa pipeline error: status $? ($!)";
176 system $OPTIPNG, "-i0", "-q", "$other~"; 318 system $OPTIPNG, "-i0", "-q", "$other~";
177 die "$other~ has zero size, aborting." unless -s "$other~"; 319 die "$other~ has zero size, aborting." unless -s "$other~";
178 rename "$other~", $other; 320 rename "$other~", $other;
179 }; 321 };
180 } 322 }
181 323
182 push @png, [$other, !$CACHE]; 324 push @c_png, [$other, !$CACHE];
183 } 325 }
184 326
185 # possibly scale down 327 # possibly scale down
186 if (0 > aio_stat "$stem.32x32.png") { 328 if (0 > aio_stat "$stem.32x32.png") {
187 my $other = "$stem.32x32.png~"; 329 my $other = "$stem.32x32.png~";
190 fork_sub { 332 fork_sub {
191 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 333 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
192 system $OPTIPNG, "-i0", "-q", "$other~"; 334 system $OPTIPNG, "-i0", "-q", "$other~";
193 335
194 # reduce smoothfaces >10000 bytes 336 # reduce smoothfaces >10000 bytes
337 # obsolete, no longer required
195 if ($stem =~ /_S\./ && (-s "$other~") > 10000) { 338 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
196 my $ncolor = 256; 339 my $ncolor = 256;
197 while () { 340 while () {
198 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E"; 341 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
199 system $OPTIPNG, "-i0", "-q", "$other~~"; 342 system $OPTIPNG, "-i0", "-q", "$other~~";
200 last if 10000 > -s "$other~~"; 343 last if 10000 > -s "$other~~";
212 rename "$other~", $other; 355 rename "$other~", $other;
213 }; 356 };
214 } 357 }
215 358
216 #warn "scaled down $path to $other\n";#d# 359 #warn "scaled down $path to $other\n";#d#
217 push @png, [$other, !$CACHE]; 360 push @c_png, [$other, !$CACHE];
218 } 361 }
219 } 362 }
220 363
221 (my $face = $stem) =~ s/^.*\///; 364 (my $face = $stem) =~ s/^.*\///;
222 365
271 414
272 if (0 > aio_load $file, $tile) { 415 if (0 > aio_load $file, $tile) {
273 die "$path: unable to read tile +$x+$y, aborting.\n"; 416 die "$path: unable to read tile +$x+$y, aborting.\n";
274 } 417 }
275 IO::AIO::aio_unlink $file unless $CACHE; 418 IO::AIO::aio_unlink $file unless $CACHE;
276 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T; 419 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
277 } 420 }
278 } else { 421 } else {
279 # use as-is (either small, use smooth) 422 # use as-is (either small, use smooth)
280 commit_png $face, $png, $T; 423 commit_png $stem, $face, $png, $T;
281 } 424 }
282 425
283 aio_unlink $path if $delete; 426 aio_unlink $path if $delete;
284 } 427 }
285 } 428 }
286 429
430 sub process_faceinfo {
431 my ($dir, $file) = @_;
432 my $path = "$dir/$file";
433
434 my $data;
435 if (0 > aio_load $path, $data) {
436 warn "$path: $!, skipping.\n";
437 return;
438 }
439
440 for (split /\n/, $data) {
441 chomp;
442 my ($face, $visibility, $fg, $bg, $glyph) = split /\s+/, $_, 5;
443 # bg not used except for text clients
444
445 utf8::decode $glyph;
446 $glyph =~ s/^\?(?=.)//; # remove "autoglyph" flag
447 $glyph =~ s/^"(.+)"$/$1/; # allow for ""-style quoting
448
449 $fg = "white" if $fg eq "none"; # lots of faces have no fg colour yet
450
451 (my $fgi = $COLOR{$fg})
452 // warn "WARNING: $path: $face specifies unknown foreground colour '$fg'.\n";
453 (my $bgi = $COLOR{$bg})
454 // warn "WARNING: $path: $face specifies unknown background colour '$bg'.\n";
455
456 my $fi = $FACEINFO{$face} ||= { };
457 $fi->{visibility} = $visibility * 1;
458 $fi->{magicmap} = $fgi; # foreground colour becomes magicmap
459
460 $glyph .= " " if 2 > length $glyph; # TODO kanji
461 die "glyph $face too long" if 2 < length $glyph;
462
463 $fi->{glyph} = "";
464 for (split //, $glyph) {
465 utf8::encode $_;
466 $fi->{glyph} .= (chr $fgi) . (chr $bgi) . $_;
467 }
468 }
469 }
470
287 sub process_arc { 471 sub process_arc {
288 while (@arc) { 472 while (my ($dir, $file) = @{ $c_arc->get }) {
289 my ($dir, $file) = @{pop @arc};
290
291 my $arc; 473 my $arc;
292 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 474 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
293 475
294 my $arc = read_arch "$dir/$file"; 476 my $arc = read_arch "$dir/$file";
295 for my $o (values %$arc) { 477 for my $o (values %$arc) {
296 push @ARC, $o; 478 push @ARC, $o;
297 for (my $m = $o; $m; $m = $m->{more}) { 479 for (my $m = $o; $m; $m = $m->{more}) {
298 $ARC{$m->{_name}} = $m; 480 $ARC{$m->{_name}} = $m;
299 } 481 }
300 482
301 $o->{editor_folder} = $dir; 483 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
302
303 my $visibility = delete $o->{visibility};
304 my $magicmap = delete $o->{magicmap};
305 484
306 # find upper left corner :/ 485 # find upper left corner :/
307 # omg, this is sooo broken 486 # omg, this is sooo broken
308 my ($dx, $dy); 487 my ($dx, $dy);
309 for (my $o = $o; $o; $o = $o->{more}) { 488 for (my $o = $o; $o; $o = $o->{more}) {
316 my $y = $o->{y} - $dy; 495 my $y = $o->{y} - $dy;
317 496
318 my $ext = $x|$y ? "+$x+$y" : ""; 497 my $ext = $x|$y ? "+$x+$y" : "";
319 498
320 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face}; 499 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
321
322 $visibility = delete $o->{visibility} if exists $o->{visibility};
323 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
324 500
325 my $anim = delete $o->{anim}; 501 my $anim = delete $o->{anim};
326 502
327 if ($anim) { 503 if ($anim) {
328 # possibly add $ext to the animation name to avoid 504 # possibly add $ext to the animation name to avoid
346 facings => $facings, 522 facings => $facings,
347 frames => \@frames, 523 frames => \@frames,
348 }; 524 };
349 } 525 }
350 526
351 for my $face ($o->{face} || (), @{$anim || []}) { 527 for ($o->{face} || (), @{$anim || []}) {
352 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 528 next if /^facings\s/;
353 529
530 my $face = $_;
531 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
532
354 my $info = $FACEINFO{$face} ||= {}; 533 my $info = $FACEINFO{$face} ||= { };
534 $info->{arc} = $o;
355 535
356 $info->{visibility} = $visibility if defined $visibility; 536 next if $face =~ /^blank.x11$|^empty.x11$/;
357 $info->{magicmap} = $magicmap if defined $magicmap;
358 } 537 }
359 538
360 if (my $smooth = delete $o->{smoothface}) { 539 if (my $smooth = delete $o->{smoothface}) {
361 my %kv =split /\s+/, $smooth; 540 my %kv = split /\s+/, $smooth;
362 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support 541 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
363 while (my ($face, $smooth) = each %kv) { 542 while (my ($face, $smooth) = each %kv) {
543 $FACEINFO{$smooth}{arc} = $o;
544
364 $FACEINFO{$face}{smooth} = $smooth; 545 $FACEINFO{$face}{smooth} = $smooth;
365 $FACEINFO{$face}{smoothlevel} = $level; 546 $FACEINFO{$face}{smoothlevel} = $level;
366 } 547 }
367 } 548 }
368 } 549 }
369 } 550 }
370 } 551 }
371 } 552 }
372 553
373 sub process_trs { 554 sub process_trs {
374 while (@trs) {
375 my ($dir, $file) = @{pop @trs}; 555 my ($dir, $file) = @_;
376 my $path = "$dir/$file"; 556 my $path = "$dir/$file";
377 557
378 my $trs; 558 my $trs;
379 if (0 > aio_load $path, $trs) { 559 if (0 > aio_load $path, $trs) {
380 warn "$path: $!, skipping.\n"; 560 warn "$path: $!, skipping.\n";
381 next; 561 return;
382 } 562 }
383 563
384 $TRS .= $trs; 564 $TRS .= $trs;
565 }
566
567 my %FILECACHE;
568
569 sub load_cached($;$) {
570 unless (exists $FILECACHE{$_[0]}) {
571 my $data;
572 if (0 < aio_load $_[0], $data) {
573 if ($_[1]) {
574 $data = eval { $_[1]->($data) };
575 warn "$_[0]: $@" if $@;
576 }
577 }
578
579 $FILECACHE{$_[0]} = $data;
580 }
581
582 $FILECACHE{$_[0]}
583 }
584
585 sub process_res {
586 my ($dir, $file, $type) = @_;
587
588 my $data;
589 aio_load "$dir/$file", $data;
590
591 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
592
593 utf8::decode $dir;
594 utf8::decode $file;
595
596 # a meta file for resources is now mandatory
597 unless (exists $meta->{$file}) {
598 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
599 return;
600 }
601
602 $meta = {
603 %{ $meta->{"" } || {} },
604 %{ $meta->{$file} || {} },
605 };
606
607 if ($meta->{license} =~ s/^#//) {
608 $meta->{license} = ({
609 "pd" => "Public Domain",
610 "gpl" => "GNU General Public License, version 3.0 or any later",
611 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
612 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
613 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
614 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
615 })->{$meta->{license}}
616 || warn "$dir/$file: license tag '$meta->{license}' not found.";
617 }
618
619 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
620 ($meta->{author} = $1) =~ s/_/ /g;
621 }
622
623 $file =~ s/\.res$//;
624 $file =~ s/\.(ogg|wav|jpg|png)$//;
625
626 substr $dir, 0, 1 + length $PATH, "";
627
628 if (my $filter = $meta->{cfutil_filter}) {
629 if ($filter eq "yaml2json") {
630 $data = JSON::XS::encode_json YAML::XS::Load $data;
631 } elsif ($filter eq "json2json") {
632 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
633 } elsif ($filter eq "perl2json") {
634 $data = eval $data; die if $@;
635 $data = JSON::XS::encode_json $data;
636 } else {
637 warn "$dir/$file: unknown filter $filter, skipping\n";
638 }
639 }
640
641 $RESOURCE{"$dir/$file"} = {
642 type => (exists $meta->{type} ? delete $meta->{type} : $type),
643 data => $data,
644 %$meta ? (meta => $meta) : (),
645 };
646 }
647
648 sub process_any {
649 while (my ($func, @args) = @{ $c_any->get }) {
650 $func->(@args);
385 } 651 }
386 } 652 }
387 653
388 sub find_files; 654 sub find_files;
389 sub find_files { 655 sub find_files {
390 my ($path) = @_; 656 my ($path) = @_;
391 657
658 my $grp = IO::AIO::aio_group;
659
660 my $scandir; $scandir = sub {
661 my ($path) = @_;
662
392 IO::AIO::aioreq_pri 4; 663 IO::AIO::aioreq_pri 4;
393 IO::AIO::aio_scandir $path, 4, sub { 664 add $grp IO::AIO::aio_scandir $path, 4, sub {
394 my ($dirs, $nondirs) = @_; 665 my ($dirs, $nondirs) = @_;
395 666
396 find_files "$path/$_" 667 $scandir->("$path/$_")
397 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 668 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
398 669
670 my $dir = $path;
671 substr $dir, 0, 1 + length $PATH, "";
672
399 for my $file (@$nondirs) { 673 for my $file (@$nondirs) {
674 if ($dir =~ /^music(?:\/|$)/) {
675 $c_any->put ([\&process_res, $path, $file, 3]) # FT_MUSIC
676 if $file =~ /\.(ogg)$/;
677
678 } elsif ($dir =~ /^sound(?:\/|$)/) {
679 $c_any->put ([\&process_res, $path, $file, 5]) # FT_SOUND
680 if $file =~ /\.(wav|ogg)$/;
681
682 } elsif ($dir =~ /^res(?:\/|$)/) {
683 if ($file =~ /\.(jpg|png)$/) {
684 $c_any->put ([\&process_res, $path, $file, 0]) # FT_FACE
685 } elsif ($file =~ /\.(res)$/) {
686 $c_any->put ([\&process_res, $path, $file, 6]) # FT_RSRC
687 } else {
688 $c_any->put ([\&process_res, $path, $file, undef]);
689 }
690
400 if ($file =~ /\.png$/) { 691 } elsif ($file =~ /\.png$/) {
401 push @png, ["$path/$file", 0]; 692 push @c_png, ["$path/$file", 0];
693
694 } elsif ($file =~ /\.faceinfo$/) {
695 $c_any->put ([\&process_faceinfo, $path, $file]);
696
402 } elsif ($file =~ /\.trs$/) { 697 } elsif ($file =~ /\.trs$/) {
403 push @trs, [$path, $file]; 698 $c_any->put ([\&process_trs, $path, $file]);
699
404 } elsif ($file =~ /\.arc$/) { 700 } elsif ($file =~ /\.arc$/) {
405 push @arc, [$path, $file]; 701 $c_arc->put ([$path, $file]);
702
406 } else { 703 } else {
407 warn "ignoring $path/$file\n" if $VERBOSE >= 3; 704 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
408 } 705 }
706 }
409 } 707 };
410 }; 708 };
709
710 $scandir->($path);
711 aio_wait $grp;
712 }
713
714 sub generate_plurals {
715# use Lingua::EN::Inflect ();
716# Lingua::EN::Inflect::classical;
717# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
718# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
719#
720# for my $a (@ARC) {
721# my $name = $a->{name} || $a->{_name};
722#
723# next unless $a->{name_pl};
724# next if $a->{invisible};
725# next if $a->{is_floor};
726# next if $a->{no_pick};
727#
728# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
729# my $pl = $test =~ /^(?:eq|p:.)$/
730# ? $name
731# : Lingua::EN::Inflect::PL $name;
732#
733# if ($pl ne $a->{name_pl}) {
734# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
735# }
736# }
411 } 737 }
412 738
413 sub inst_arch($) { 739 sub inst_arch($) {
414 my (undef, $path) = @_; 740 my (undef, $path) = @_;
741
742 $PATH = $path;
415 743
416 print "\n", 744 print "\n",
417 "Installing '$path' to '$DATADIR'\n", 745 "Installing '$path' to '$DATADIR'\n",
418 "\n", 746 "\n",
419 "This can take a long time if you run this\n", 747 "This can take a long time if you run this\n",
426 if (!-d "$path/treasures") { 754 if (!-d "$path/treasures") {
427 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 755 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
428 exit 1 unless $FORCE; 756 exit 1 unless $FORCE;
429 } 757 }
430 758
759 print "start file scan, arc, any processing...\n" if $VERBOSE;
760
761 my @a_arc = map +(async \&process_arc), 1..2;
762 my @a_any = map +(async \&process_any), 1..4;
763
431 find_files $path; 764 find_files $path;
432 IO::AIO::flush;
433 765
434 $_->join for ( 766 $c_arc->shutdown;
767 $c_any->shutdown;
768
769 $_->join for @a_arc; # need to parse all archetypes before png processing
770
771 print "end arc, start png processing...\n" if $VERBOSE;
772
435 # four png crunchers work fine for my 2x smp machine 773 # eight png crunchers work fine for my 4x smp machine
436 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 774 my @a_png = map +(async \&process_png), 1..8;
437 (async \&process_trs), (async \&process_trs),
438 (async \&process_arc), (async \&process_arc),
439 );
440 775
776 print "end any processing...\n" if $VERBOSE;
777 $_->join for @a_any;
778
779 print "end png processing...\n" if $VERBOSE;
780 $_->join for @a_png;
781
782 print "scanning done, processing results...\n" if $VERBOSE;
441 { 783 {
442 # remove path prefix from editor_folder 784 # remove path prefix from editor_folder
785 $_->{editor_folder} =~ /^\x00/
443 substr $_->{editor_folder}, 0, 1 + length $path, "" 786 and substr $_->{editor_folder}, 0, 2 + length $path, ""
444 for values %ARC; 787 for values %ARC;
445 788
789 print "resolving inheritance tree...\n" if $VERBOSE;
446 # resolve inherit 790 # resolve inherit
447 while () { 791 while () {
448 my $progress; 792 my $progress;
449 my $loop; 793 my $loop;
450 794
451 for my $o (values %ARC) { 795 for my $o (values %ARC) {
452 if (my $other = $o->{inherit}) { 796 for my $other (split /,/, $o->{inherit}) {
453 if (my $s = $ARC{$other}) { 797 if (my $s = $ARC{$other}) {
454 if ($s->{inherit}) { 798 if ($s->{inherit}) {
455 $loop = $s; 799 $loop = $s;
456 } else { 800 } else {
457 delete $o->{inherit}; 801 delete $o->{inherit};
459 delete @s{qw(_name more name name_pl)}; 803 delete @s{qw(_name more name name_pl)};
460 %$o = ( %s, %$o ); 804 %$o = ( %s, %$o );
461 ++$progress; 805 ++$progress;
462 } 806 }
463 } else { 807 } else {
464 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n"; 808 warn "WARNING: archetype '$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
465 delete $ARC{$o->{_name}}; 809 delete $ARC{$o->{_name}};
466 } 810 }
467 } 811 }
468 } 812 }
469 813
476 } 820 }
477 821
478 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit 822 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
479 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC; 823 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
480 824
825 # fix up archetypes without names, where the archanme doesn't work at all
826 for (@ARC) {
827 if (!exists $_->{name} and $_->{_name} =~ /_/) {
828 for ($_->{name} = $_->{_name}) {
829 s/(?:_\d+)+$//;
830 s/_[nesw]+$//;
831 y/_/ /;
832 }
833 }
834 }
835
836 #print "generating plurals...\n" if $VERBOSE;
837 #generate_plurals;
838
839 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
481 open my $fh, ">:utf8", "$DATADIR/archetypes~" 840 open my $fh, ">:utf8", "$DATADIR/archetypes~"
482 or die "$DATADIR/archetypes~: $!"; 841 or die "$DATADIR/archetypes~: $!";
483 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC]; 842 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
484 } 843 }
485 844
486 { 845 {
846 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
487 open my $fh, ">:utf8", "$DATADIR/treasures~" 847 open my $fh, ">:utf8", "$DATADIR/treasures~"
488 or die "$DATADIR/treasures~: $!"; 848 or die "$DATADIR/treasures~: $!";
489 print $fh $TRS; 849 print $fh $TRS;
490 } 850 }
491 851
492 { 852 {
853 print "processing facedata...\n" if $VERBOSE;
493 while (my ($k, $v) = each %FACEINFO) { 854 while (my ($k, $v) = each %FACEINFO) {
494 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 855 length $v->{data32} or warn "WARNING: face '$k' has no png32. this will not work (shoddy gcfclient will crash of course).\n";
495 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n"; 856 length $v->{data64} or warn "WARNING: face '$k' has no png64. this will not work very well.\n";
496 857
858 make_hash $k, $v->{data32}, $v->{hash32};
859 make_hash $k, $v->{data64}, $v->{hash64};
860
497 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 861 #length $v->{data32} <= 10000 or warn "WARNING: face '$k' has face32 larger than 10000 bytes, will not work with crossfire client.\n";
498 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 862 #length $v->{data64} <= 10000 or warn "WARNING: face '$k' has face64 larger than 10000 bytes.\n";
499 863
500 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 864 $v->{glyph} // warn "WARNING: face '$k' has glyph.";
501 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 865 $v->{visibility} // warn "WARNING: face '$k' has no visibility info, missing faceinfo entry?\n";
866 $v->{magicmap} // warn "WARNING: face '$k' has foreground colour.";
502 867
503 if (my $magicmap = $v->{magicmap}) { 868 delete @$v{qw(arc stem)}; # not used by the server
504 $magicmap =~ y/A-Z_\-/a-z/d; 869 }
505 $v->{magicmap} = $COLOR{$magicmap}; 870
871 print "processing resources...\n" if $VERBOSE;
872 my $enc = JSON::XS->new->utf8->canonical->relaxed;
873 while (my ($k, $v) = each %RESOURCE) {
874
875 if ($v->{meta} && $v->{meta}{datadir}) {
876 delete $RESOURCE{$k};
877
878 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
879
880 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
881 open my $fh, ">:raw", "$DATADIR/$k~"
882 or die "$DATADIR/$k~: $!";
883 syswrite $fh, $v->{data};
884 push @COMMIT, $k;
885
886 } else {
887 if ($v->{type} & 1) {
888 # prepend meta info
889
890 my $meta = $enc->encode ({
891 name => $k,
892 %{ $v->{meta} || {} },
893 });
894
895 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
506 } 896 }
897
898 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
507 } 899 }
900 }
901
902 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
903 scalar keys %FACEINFO,
904 scalar keys %ANIMINFO,
905 scalar keys %RESOURCE
906 if $VERBOSE;
508 907
509 open my $fh, ">:perlio", "$DATADIR/facedata~" 908 open my $fh, ">:perlio", "$DATADIR/facedata~"
510 or die "$DATADIR/facedata~: $!"; 909 or die "$DATADIR/facedata~: $!";
511 910
512 print $fh freeze { 911 print $fh nfreeze {
513 version => 2, 912 version => 2,
514 faceinfo => \%FACEINFO, 913 faceinfo => \%FACEINFO,
515 animinfo => \%ANIMINFO, 914 animinfo => \%ANIMINFO,
915 resource => \%RESOURCE,
516 }; 916 };
517 }
518 917
918 }
919
920 print "committing files...\n" if $VERBOSE;
921
519 for (qw(archetypes facedata treasures)) { 922 for (qw(archetypes facedata treasures), @COMMIT) {
520 chmod 0644, "$DATADIR/$_~"; 923 chmod 0644, "$DATADIR/$_~";
521 rename "$DATADIR/$_~", "$DATADIR/$_" 924 rename "$DATADIR/$_~", "$DATADIR/$_"
522 or die "$DATADIR/$_: $!"; 925 or die "$DATADIR/$_: $!";
523 } 926 }
524 927

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines